#ifndef smdbgen_h_
#define smdbgen_h_
#include <stdio.h>

#define ENDL(A) fputc(0x0D, A); fputc(0x0A, A)

#define STATIC_HEADER_SIZE 13
#define DOOR_OUT 9
#define PLM 22		// 22 bytes after the address at which the standard events pointer is located in the room header

#define NUM_CHKS 4

#define SIZEOF_BANK 0x8000
#define BEGIN_BANK 0x8000
#define BEGIN_8F 0x78000
#define END_8F 0x80000
#define BEGIN_83 0x18000
#define END_83 0x20000

typedef struct {
	int roomc;
	unsigned int *roomv;
	unsigned int *hsizes;
} mdb_t;

unsigned int wtoi(unsigned char *word);
unsigned int lwtoi(unsigned char *longword);
unsigned char *itow(unsigned int val);
unsigned char *itolw(unsigned int val);
unsigned int snes2pc(unsigned int addr);
unsigned int pc2snes(unsigned int addr);
mdb_t *mdb_create(int roomc);
void mdb_destroy(mdb_t *mdb);
int follow(FILE *rom, int offset, int bank);
int isptr(FILE *rom);
int isdoor(FILE *rom);
int calc_hsize(FILE *rom, int offset);
mdb_t *smdbgen(FILE *rom, int verbosity);

#endif
